#include <Core/Core.h>
#include <VarArgs/VarArgs.h>

using namespace Upp;

String str_cpp = "This is a demonstration of the VarArgs class of C++!";

bool PrintNumberViaGate(int i) 
{
	Cout() << "Number printed via gate: " << i << "\r\n";
	return false;
}
void Foo(VarArgs& va) 
{
	Cout() << va.Get<int>(0) << "\r\n";
	Cout() << va.Get<float>(1) << "\r\n";
	Cout() << va.Get<String>(2) << "\r\n";

	String* str_upp = va.Get<String*>(3);
	str_upp->Set(str_upp->ReverseFind('C'), 'U');
	Cout() << str_cpp << "\r\n";

	Gate1<int> cb = va.Get<Gate1<int> >(4);
	cb(9999);
}

CONSOLE_APP_MAIN
{
	Foo(VarArgs() << 10 << 22.33f << String("Hello World!") << &str_cpp << callback(PrintNumberViaGate));
//	Same thing can be done via explicit calls.
//	VarArgs va;
//	va	.Add(10)
//		.Add(22.33f)
//		.Add(String("Hello World!"))
//		.Add(&str_cpp)
//		.Add(callback(PrintNumberViaGate));
//	Foo(va);	

}
